#include <stdlib.h>

#include "IntrusiveLinkedList.h"
#include "nanojit.h"

namespace nanojit
{

IntrusiveLinkedList::IntrusiveLinkedList()
{
}

IntrusiveLinkedList::~IntrusiveLinkedList()
{

}

void IntrusiveLinkedList::clear()
{
	// circular design, will simplify insertion/deletion logic
	m_oRoot.m_pNext         = &m_oRoot;
	m_oRoot.m_pPrevious     = &m_oRoot;
}


void IntrusiveLinkedList::insert(IntrusiveListNode* a_pNode, IntrusiveListNode* a_pElementBefore, IntrusiveListNode* a_pElementAfter)
{
	NanoAssert(a_pElementBefore->m_pNext == a_pElementAfter);
	NanoAssert(a_pElementAfter->m_pPrevious == a_pElementBefore);

	a_pNode->m_pPrevious            = a_pElementBefore;
	a_pNode->m_pNext                = a_pElementAfter;


	a_pElementBefore->m_pNext       = a_pNode;
	a_pElementAfter->m_pPrevious    = a_pNode;
}

void IntrusiveLinkedList::remove(IntrusiveListNode* a_pNode)
{
	a_pNode->m_pPrevious->m_pNext       = a_pNode->m_pNext;
	a_pNode->m_pNext->m_pPrevious       = a_pNode->m_pPrevious;

	a_pNode->m_pNext = NULL;
	a_pNode->m_pPrevious = NULL;
}



}

